package salescmp.Bean;

import java.util.*;
import java.rmi.*;
import javax.ejb.*;
import javax.naming.*;
import salescmp.Util.*;

public abstract class PackedSalesBean implements EntityBean {
  private EntityContext context;

  public abstract void setSalesNo(Integer salesno);
  public abstract Integer getSalesNo();

  public abstract void setCustomer(Customer cust);
  public abstract Customer getCustomer();

  public abstract void setEmployee(Employee emp);
  public abstract Employee getEmployee();

  public abstract void setSalesDate(java.sql.Date salesDate);
  public abstract java.sql.Date getSalesDate();

  public abstract void setDetails(Collection details);
  public abstract Collection getDetails();

  public Integer ejbCreate(int salesno, int custid, int empid,
        java.sql.Date salesDate) throws CreateException {
    setSalesNo(new Integer(salesno));
    setCustomer(SalesUtil.findCustomerById(custid));
    setEmployee(SalesUtil.findEmployeeById(empid));
    setSalesDate(salesDate);
    return new Integer(salesno);
  }

  public void ejbPostCreate(int salesno, int custid, int empid,
        java.sql.Date salesDate) throws CreateException {
  }

  public void setEntityContext(EntityContext context) {
    this.context = context;
  }

  public void unsetEntityContext() {
    context = null;
  }

  public void ejbRemove() throws RemoveException {}
  public void ejbActivate() {}
  public void ejbPassivate() {}
  public void ejbLoad() {}
  public void ejbStore() {}

  ////////////////////////////////////////////////////////////////////////
  //  ǉ\bh
  ////////////////////////////////////////////////////////////////////////
  //  ׍sf[^ArrayListŕԂ
  public ArrayList getSalesList() {
    ArrayList list = new ArrayList();
    Iterator itr = getDetails().iterator();
    while (itr.hasNext()) {
      list.add((Sales)itr.next());
    }
    return list;
  }

  //  `[̍vz擾
  public double getTotal() {
    double res = 0.0;
    Iterator itr = getSalesList().iterator();
    while (itr.hasNext()) {
      res += ((Sales)(itr.next())).getSalesCost();
    }
    return res;
  }

}