package salescmp.Bean;

import java.util.*;
import java.rmi.*;
import javax.ejb.*;
import javax.naming.*;
import salescmp.Util.*;

public class SalesSessionBean implements SessionBean {
  private SessionContext context;

  public ArrayList getAllCustomers() {
    return allCustomers();
  }

  public ArrayList getAllPackedSales() {
    return allPackedSales();
  }

  public ArrayList getCustomerPackedSales(int custid) {
    return SalesUtil.findCustomerById(custid).getPackedSalesList();
  }

///////////////////////////////////////////////////////////////////////////
//  Customer C^[tFCX
///////////////////////////////////////////////////////////////////////////
  //  Customer
  public void createCustomer(int id, String name, String address, String tel,
        String fax) {
    try {
      Context ctx = new InitialContext();
      CustomerHome home = (CustomerHome)ctx.lookupLink(SalesUtil.CUSTOMER_REF);
      home.create(id, name, address, tel, fax);
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (CreateException ex) {
      throw new EJBException(ex.getMessage());
    }
  }

  public void removeCustomer(int id){
    try {
      Context ctx = new InitialContext();
      CustomerHome home = (CustomerHome)ctx.lookupLink(SalesUtil.CUSTOMER_REF);
      Customer cust = home.findByPrimaryKey(new Integer(id));
      cust.remove();
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException(ex.getMessage());
    } catch (RemoveException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

  public CustomerData getCustomerData(int id) {
    try {
      Context ctx = new InitialContext();
      CustomerHome home = (CustomerHome)ctx.lookupLink(SalesUtil.CUSTOMER_REF);
      Customer cust = home.findByPrimaryKey(new Integer(id));
      //  {ŃG[
      return new CustomerData(id, cust.getName(), cust.getAddress(),cust.getTel(),
              cust.getFax());
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException(ex.getMessage());
    }
  }

  public void updateCustomer(CustomerData cdata) {
    try {
      Context ctx = new InitialContext();
      CustomerHome home = (CustomerHome)ctx.lookupLink(SalesUtil.CUSTOMER_REF);
      Customer cust = home.findByPrimaryKey(new Integer(cdata.getId()));
      //  {ŃG[
      cust.setName(cdata.getName());
      cust.setAddress(cdata.getAddress());
      cust.setTel(cdata.getTel());
      cust.setFax(cdata.getFax());
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException(ex.getMessage());
    }
  }

///////////////////////////////////////////////////////////////////////////
//  PackedSales
///////////////////////////////////////////////////////////////////////////
  public void createPackedSales(PackedSalesData pdata) {
    if (pdata.hasValidDetail()) {
      try {
        Context ctx = new InitialContext();

         //////////////////////////////////////////////////////////////////
         //  `[wb_쐬
         //////////////////////////////////////////////////////////////////
        PackedSalesHome phome = (PackedSalesHome)ctx.lookupLink(SalesUtil.PACKEDSALES_REF);
        phome.create(pdata.getSalesNo(), pdata.getCustomerId(), pdata.getEmployeeId(),
            pdata.getSalesDate());
        ///////////////////////////////////////////////////////////////////
        //  ׍s쐬
        ///////////////////////////////////////////////////////////////////
        SalesHome shome = (SalesHome)ctx.lookupLink(SalesUtil.SALES_REF);
        for (int line = 0 ; line < pdata.LINES; line++) {
          /////////////////////////////////////////////////////////////////
          //  ׍sLłΖ׍sf[^쐬
          //  ׍sID͓`[NO * 10 + ׍sԍĂ
          if (pdata.isValidDetail(line)){
            shome.create( pdata.getSalesNo() * 10 + pdata.getDetailNo(line),  //׍sID
                          pdata.getDetailNo(line),
                          pdata.getSalesNo(),
                          pdata.getProductId(line),
                          pdata.getQuantity(line));
          }
        }
      } catch (NamingException ex) {
        throw new EJBException(ex.getMessage());
      } catch (CreateException ex) {
        throw new EJBException(ex.getMessage());
      }
    }
  }


///////////////////////////////////////////////////////////////////////////
//  ѓ
///////////////////////////////////////////////////////////////////////////
  public void insertDatas(boolean errTest) {
    insertEmployees();
    insertCustomers();
    insertProducts(errTest);
  }

///////////////////////////////////////////////////////////////////////////
//  ܂
///////////////////////////////////////////////////////////////////////////
  public void ejbCreate() {
  }
  public void ejbRemove() {
  }
  public void ejbActivate() {
  }
  public void ejbPassivate() {
  }
  public void setSessionContext(SessionContext context) {
    this.context = context;
  }

  ////////////////////////////////////////////////////////////////////////
  //  private
  ////////////////////////////////////////////////////////////////////////

  private void insertEmployees() {
    try {
      Context ctx = new InitialContext();
      EmployeeHome home = (EmployeeHome)ctx.
            lookupLink("java:comp/env/ejb/EmployeeRef");
      home.create(1, "H ͗m");
      home.create(2, "{ q");
      home.create(3, " O]");
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (CreateException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

  private void insertCustomers() {
    try {
      Context ctx = new InitialContext();
      CustomerHome home = (CustomerHome)ctx.
            lookup("java:comp/env/ejb/CustomerRef");
      home.create(11, " O", "a̎Ra̎Rs","073-123-XXXX","073-123-XXXX");
      home.create(12, " G","sc","03-3158-XXXX","03-3258-XXXX");
      home.create(13, "k _","{sk","06-1234-XXXX","06-1234-XXXX");
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (CreateException ex) {
      throw new EJBException (ex.getMessage());
    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private void insertProducts(boolean errTest) {
    try {
      Context ctx = new InitialContext();
      ProductHome home = (ProductHome)ctx.
            lookupLink("java:comp/env/ejb/ProductRef");
      home.create(101, "er", 25000);
      home.create(102, "rfI", 12000);
      home.create(103, "MDv[[", 23500);
    ////////////////////////////////////////////////////////////////////////
    //   primary key deXg
    //  VXeG[𔭐̂ŁAȂĂׂă[obNĂ͂
    ///////////////////////////////////////////////////////////////////////
      if (errTest) {
        SalesUtil.trace("keyᔽ");
        home.create(101, "XeI", 56000);
      }
   } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (CreateException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

  private ArrayList allCustomers() {
    ArrayList list = new ArrayList();
    try {
      Context ctx = new InitialContext();
      CustomerHome home = (CustomerHome)ctx.
            lookupLink(SalesUtil.CUSTOMER_REF);
      Iterator itr = home.findAllCustomers().iterator();
      while (itr.hasNext()) {
        list.add((Customer)itr.next());
      }
      return list;
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

  private ArrayList allPackedSales() {
    ArrayList list = new ArrayList();
    try {
      Context ctx = new InitialContext();
      PackedSalesHome home = (PackedSalesHome)ctx.
            lookupLink(SalesUtil.PACKEDSALES_REF);
      Iterator itr = home.findAllPackedSales().iterator();
      while (itr.hasNext()) {
        list.add((PackedSales)itr.next());
      }
      return list;
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

}