package salescmp.Util;

public class PackedSalesData {
  public static final int LINES = 4;     //׍s

  private int _salesNo;
  private int _customerId;
  private int _employeeId;
  private java.sql.Date _salesDate;
  private Detail[] _details = new Detail[LINES];

  public PackedSalesData(int sno, int cid, int eid, java.sql.Date sdate) {
    _salesNo = sno;
    _customerId = cid;
    _employeeId = eid;
    _salesDate = sdate;
    for (int i = 0; i < LINES; i++)
      _details[i] = new Detail();
  }

  public int getSalesNo() {
    return _salesNo;
  }

  public int getEmployeeId() {
    return _employeeId;
  }

  public int getCustomerId() {
    return _customerId;
  }

  public java.sql.Date getSalesDate() {
    return _salesDate;
  }

  public void setDetailId(int id, int lno) {
    _details[lno].setDetailNo(id);
  }
  public int getDetailId(int lno) {
    return _details[lno].getDetailId();
  }


  public void setDetailNo(int no, int lno) {
    _details[lno].setDetailNo(no);
  }
  public int getDetailNo(int lno) {
    return _details[lno].getDetailNo();
  }

  public void setProductId(int id, int lno) {
    _details[lno].setProductId(id);
  }
  public int getProductId(int lno) {
    return _details[lno].getProductId();
  }

  public void setQuantity(double qty, int lno) {
    _details[lno].setQuantity(qty);
  }
  public double getQuantity(int lno) {
    return _details[lno].getQuantity();
  }

////////////////////////////////////////////////////////////////////////
//  ׍se`FbN
//  iIDAʗƂ0Ŗΐ׍sƂĂB
////////////////////////////////////////////////////////////////////////
  public boolean isValidDetail(int line) {
    return _details[line].isValidDetail();
  }

////////////////////////////////////////////////////////////////////////
//  `[f[^uv׍s`FbN
////////////////////////////////////////////////////////////////////////
  public boolean hasValidDetail() {
    boolean res = false;
    for (int line = 0; line <= LINES; line++) {
      if (_details[line].isValidDetail()) {
        res = true;
        break;
      }
    }
    return res;
  }
}

class Detail {
  private int _detailId;
  private int _detailNo;
  private int _productId;
  private double _quantity;

  Detail() {
    super();
  }

  void setDetailId(int id) {
    _detailId = id;
  }
  int getDetailId() {
    return _detailId;
  }

  void setDetailNo(int no) {
    _detailNo = no;
  }
  int getDetailNo() {
    return _detailNo;
  }

  void setProductId(int id) {
    _productId = id;
  }
  int getProductId() {
    return _productId;
  }

  void setQuantity(double qty) {
    _quantity = qty;
  }
  double getQuantity() {
    return _quantity;
  }

////////////////////////////////////////////////////////////////////////
//  ׍se`FbN
//  iIDAʗƂ0Ŗΐ׍sƂĂB
////////////////////////////////////////////////////////////////////////
  boolean isValidDetail() {
    return ((getProductId() != 0) && (getQuantity() != 0.0));
  }

}