package salescmp.Util;

import java.io.*;
import javax.naming.*;
import javax.ejb.*;
import salescmp.Bean.*;

public class SalesUtil {

////////////////////////////////////////////////////////////////////////
//  JNDI Reference Names
////////////////////////////////////////////////////////////////////////
  public static final String EMPLOYEE_REF = "java:comp/env/ejb/EmployeeRef";
  public static final String CUSTOMER_REF = "java:comp/env/ejb/CustomerRef";
  public static final String SALES_REF    = "java:comp/env/ejb/SalesRef";
  public static final String PACKEDSALES_REF   = "java:comp/env/ejb/PackedSalesRef";
  public static final String PRODUCT_REF  = "java:comp/env/ejb/ProductRef";
  public static final String SESSION_REF  = "java:comp/env/ejb/SalesSessionRef";

  public static String convJp(String str) {
    if (str == null)
      return str;
    try {
      return new String(str.getBytes("iso-8859-1"), "Shift_JIS");
    } catch (UnsupportedEncodingException ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public static void trace(String msg) {
    System.out.println("TRACE :" + msg);
  }

  public static SalesSession getSalesSession() throws
          NamingException, CreateException{
    return getSalesSessionHome().create();
  }

  public static SalesSessionHome getSalesSessionHome() throws
          NamingException, CreateException{
    InitialContext ic = new InitialContext();
    SalesSessionHome home = (SalesSessionHome)ic.lookupLink
          (SESSION_REF);
    return home;
  }


  public static  Employee findEmployeeById(int id) {
    try {
      Context ic = new InitialContext();
      EmployeeHome home = (EmployeeHome) ic.lookupLink(EMPLOYEE_REF);
      return home.findByPrimaryKey(new Integer(id));
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

  public static Customer findCustomerById(int id) {
    try {
      Context ic = new InitialContext();
      CustomerHome home = (CustomerHome) ic.lookupLink(CUSTOMER_REF);
      return home.findByPrimaryKey(new Integer(id));
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

  public static Sales findSalesById(int id) {
    try {
      Context ic = new InitialContext();
      SalesHome home = (SalesHome) ic.lookupLink(SALES_REF);
      return home.findByPrimaryKey(new Integer(id));
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

  public static PackedSales findPackedSalesById(int id) {
    try {
      Context ic = new InitialContext();
      PackedSalesHome home = (PackedSalesHome) ic.lookupLink(PACKEDSALES_REF);
      return home.findByPrimaryKey(new Integer(id));
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException (ex.getMessage());
    }
  }

  public static Product findProductById(int id) {
    try {
      Context ic = new InitialContext();
      ProductHome home = (ProductHome) ic.lookupLink(PRODUCT_REF);
      return home.findByPrimaryKey(new Integer(id));
    } catch (NamingException ex) {
      throw new EJBException(ex.getMessage());
    } catch (FinderException ex) {
      throw new EJBException (ex.getMessage());
    }
  }
}
